///////////////////////////////
//	ChangePointAnalyzeNorm.cc
//	C interaction file 

#include "mex.h" 
#include <cmath>
#include "Gamma.h"
#include "Gamma.cpp"





using std::log;

void ChangePointAnalyzeNorm(double *RetMl, mwSize *RetCha, const double *Data,mwSize InputLength, mwSize MaxJump, double *Prior) {


mwSize TSize =InputLength;
mwSize MaxJ= MaxJump;

double *SufStatSum= new double[TSize];
double *SufStatSumofSq= new double[TSize];



mwSize ii;
mwSize jj;
mwSize kk;

for(ii=0;ii<TSize;ii++){
  SufStatSum[ii]=0;
  SufStatSumofSq[ii]=0;
}

double *Temp=new double;

double P_mu=Prior[0];
double P_kappa=Prior[1];
double P_nu=Prior[2];
double P_sigma=Prior[3];

for (ii=0; ii<TSize; ii++){

     double *NewEst= new double[ii+1];
     
     for (kk=0; kk<=ii;kk++){ 
     
     SufStatSum[kk]+= Data[ii];
     SufStatSumofSq[kk]+= Data[ii]*Data[ii];
     NewEst[kk]=0;
     NewEst[kk]=NewEst[kk]+std::log(P_kappa/(ii-kk+1+P_kappa))/2+P_nu/2*(std::log(P_sigma)+std::log(P_nu))-(ii-kk+1+P_nu)/2*std::log(SufStatSumofSq[kk]-(SufStatSum[kk]*SufStatSum[kk])/(ii-kk+1)+P_sigma*P_nu+(ii-kk+1)*P_kappa*std::pow(SufStatSum[kk]/(ii-kk+1)-P_mu,2)/(ii-kk+1+P_kappa))+LogGamma((ii-kk+1+P_nu)/2)-LogGamma(P_nu/2);
     
     }

     RetMl[ii*MaxJ]=NewEst[0];
     RetCha[ii*MaxJ]=0;

     for (jj=1;jj<MaxJ & jj<=ii;jj++){

      RetMl[ii*MaxJ+jj]=NewEst[ii]+RetMl[(ii-1)*MaxJ+jj-1];
      RetCha[ii*MaxJ+jj]=ii;
      
      for (kk=ii-1;kk>=jj;kk--){

        *Temp=NewEst[kk]+RetMl[(kk-1)*MaxJ+jj-1];

        if (*Temp>RetMl[ii*MaxJ+jj]){
           RetMl[ii*MaxJ+jj]=*Temp;
           RetCha[ii*MaxJ+jj]=kk;
        }
      
      }
     
     }
     
     delete [] NewEst;

}



delete [] SufStatSum;
delete [] SufStatSumofSq;

delete Temp;
return; // Return Nothing.
}




void mexFunction( int nlhs, mxArray *plhs[],
                  int nrhs, const mxArray *prhs[])
{
    double *inData; 
    mwSize inInputLength;
    mwSize inMaxJump;
    double *inPrior;

    double *outRetMl;
    mwSize *outRetCha;
   
    inData = mxGetPr(prhs[0]);
    inInputLength = (mwSize ) mxGetScalar(prhs[1]);
    inMaxJump =  (mwSize ) mxGetScalar(prhs[2]);
    inPrior=mxGetPr(prhs[3]);

    plhs[0] = mxCreateDoubleMatrix(1,inInputLength*inMaxJump,mxREAL);
    plhs[1] = mxCreateNumericMatrix(1,inInputLength*inMaxJump,mxUINT32_CLASS,mxREAL);
    outRetMl = mxGetPr(plhs[0]);
    outRetCha = (mwSize *) mxGetData(plhs[1]);

    ChangePointAnalyzeNorm(outRetMl,outRetCha,inData,inInputLength,inMaxJump,inPrior);
}



