///////////////////////////////
//	ChangePointAnalyzePoiss.cc
//	C interaction file 

#include "mex.h" 
#include <cmath>
#include "Gamma.h"
#include "Gamma.cpp"

using std::log;
using std::exp;



void ChangePointAnalyzePoiss(double *RetMl, int *RetCha, const double *Data,mwSize InputLength, mwSize MaxJump,double *Prior) {


mwSize TSize =InputLength;
mwSize MaxJ= MaxJump;

double *SufStat= new double[TSize];

mwSize ii;
mwSize jj;
mwSize kk;

for(ii=0;ii<TSize;ii++){
  SufStat[ii]=0;
}

double *Temp=new double;

double P_alpha=Prior[0];
double P_beta=Prior[1];

for (ii=0; ii<TSize; ii++){
     

     double *NewEst= new double[ii+1];
     
     for (kk=0; kk<=ii;kk++){ 
     
     SufStat[kk]+= Data[ii];
     NewEst[kk]=0;
     NewEst[kk]=NewEst[kk]+LogGamma(SufStat[kk]+P_alpha)-(SufStat[kk]+P_alpha)*std::log(ii-kk+1+P_beta)+P_alpha*std::log(P_beta)-LogGamma(P_alpha);

     }
     
     RetMl[ii*MaxJ]=NewEst[0];
     RetCha[ii*MaxJ]=0;
     
     for (jj=1;jj<MaxJ & jj<=ii;jj++){
     
      RetMl[ii*MaxJ+jj]=NewEst[ii]+RetMl[(ii-1)*MaxJ+jj-1];
      RetCha[ii*MaxJ+jj]=ii;
      
      for (kk=ii-1;kk>=jj;kk--){
      
        *Temp=NewEst[kk]+RetMl[(kk-1)*MaxJ+jj-1];
          
        if (*Temp>RetMl[ii*MaxJ+jj]){
           RetMl[ii*MaxJ+jj]=*Temp;
           RetCha[ii*MaxJ+jj]=kk;
        }
      
      }
      
     }
     
     delete [] NewEst;
}

delete [] SufStat;
delete Temp;
return; // Return Nothing.
}

void mexFunction( int nlhs, mxArray *plhs[],
                  int nrhs, const mxArray *prhs[])
{
    double *inData; 
    mwSize inInputLength;
    mwSize inMaxJump;
    double *inPrior;

    double *outRetMl;
    mwSize *outRetCha;
   
    inData = mxGetPr(prhs[0]);
    inInputLength = (mwSize ) mxGetScalar(prhs[1]);
    inMaxJump =  (mwSize ) mxGetScalar(prhs[2]);
    inPrior=mxGetPr(prhs[3]);

    plhs[0] = mxCreateDoubleMatrix(1,inInputLength*inMaxJump,mxREAL);
    plhs[1] = mxCreateNumericMatrix(1,inInputLength*inMaxJump,mxUINT32_CLASS,mxREAL);
    outRetMl = mxGetPr(plhs[0]);
    outRetCha = (mwSize *) mxGetData(plhs[1]);

    ChangePointAnalyzePoiss(outRetMl,outRetCha,inData,inInputLength,inMaxJump,inPrior);
}

