///////////////////////////////
//	ChangePointAnalyzePoissUnRes.cc
//	C interaction file 

#include "mex.h" 
#include <cmath>
#include "Gamma.h"
#include "Gamma.cpp"

using std::log;
using std::exp;


void ChangePointAnalyzePoissUnRes(double *RetMl, int *RetCha, const double *Data,mwSize InputLength,double *Prior) {


mwSize TSize =InputLength;

double *SufStat= new double[TSize];

mwSize ii;
mwSize kk;

for(ii=0;ii<TSize;ii++){
  SufStat[ii]=0;
}

double *Temp=new double;

double P_alpha=Prior[0];
double P_beta=Prior[1];

for (ii=0; ii<TSize; ii++){
     

     double *NewEst= new double[ii+1];
     
     for (kk=0; kk<=ii;kk++){ 
     
     SufStat[kk]+= Data[ii];
     NewEst[kk]=0;
     NewEst[kk]=NewEst[kk]+LogGamma(SufStat[kk]+P_alpha)-(SufStat[kk]+P_alpha)*std::log(ii-kk+1+P_beta)+P_alpha*std::log(P_beta)-LogGamma(P_alpha);

     }
     
     RetMl[ii]=NewEst[0];
     RetCha[ii]=0;
     
      for (kk=1;kk<=ii;kk++){

        *Temp=NewEst[kk]+RetMl[kk-1];

        if (*Temp>RetMl[ii]){
           RetMl[ii]=*Temp;
           RetCha[ii]=kk;
        }
      
      }
     
     delete [] NewEst;
}

delete [] SufStat;
delete Temp;
return; // Return Nothing.
}

void mexFunction( int nlhs, mxArray *plhs[],
                  int nrhs, const mxArray *prhs[])
{
    double *inData; 
    mwSize inInputLength;
    double *inPrior;

    double *outRetMl;
    mwSize *outRetCha;
   
    inData = mxGetPr(prhs[0]);
    inInputLength = (mwSize ) mxGetScalar(prhs[1]);
    inPrior=mxGetPr(prhs[2]);

    plhs[0] = mxCreateDoubleMatrix(1,inInputLength,mxREAL);
    plhs[1] = mxCreateNumericMatrix(1,inInputLength,mxUINT32_CLASS,mxREAL);

    outRetMl = mxGetPr(plhs[0]);
    outRetCha = (mwSize *) mxGetData(plhs[1]);

    ChangePointAnalyzePoissUnRes(outRetMl,outRetCha,inData,inInputLength,inPrior);
}



