function [index_chPTs,log_H,max_j]=est_changepoints(data_x, model, prior, max_segs,logMD)
  % The Notations are in consistent with Du, Kao and Kou (2013)

     [Dim,n] = size(data_x);
 
  if strcmp(model,'normal')==1 && Dim==1
		if ~exist('max_segs','var')
        [log_H,max_j]=ChangePointAnalyzeNormUnRes(data_x,n,prior);    
        else
        [log_H,max_j]=ChangePointAnalyzeNorm(data_x,n,max_segs,prior);    
		log_H=reshape(log_H,max_segs,n);
		max_j=reshape(max_j,max_segs,n);
        end
  elseif strcmp(model,'poisson')==1 && Dim==1
		if ~exist('max_segs','var')
        [log_H,max_j]=ChangePointAnalyzePoissUnRes(data_x,n,prior);    
        else
        [log_H,max_j]=ChangePointAnalyzePoiss(data_x,n,max_segs,prior);    
		log_H=reshape(log_H,max_segs,n);
		max_j=reshape(max_j,max_segs,n);
        end		
  elseif strcmp(model,'user')==1 && exist('prior','var') && exist('max_segs','var') && exist('logMD')
      % logH[m,i] := logH(data_x[1:i] | m)
      log_H = zeros(max_segs, n); 
      % maxJ[m,i] = m <=> H(data_x[1:i]|m) = H(data_x[1:j]|m-1)*D(data_x[j+1:i])
      max_j = zeros(max_segs,n);
      % H(data_x[1]|1) = D(data_x[1])
      log_H(1,1) = logMD(data_x(:,1), prior);
      % Recursively compute H for i>2
      for i=2:1:n
        % log.D[j] := logD(xj, ..., xi)
        for j=1:1:i
            log_D(j) = logMD(data_x(:,j:i), prior);
        end
        % H(x1,...,xi|1) = D(data[1:i])
        log_H(1,i) = log_D(1);
        % Recursively compute H for m>2
        max_m_given_i = min(i, max_segs);
        for m=2:1:max_m_given_i
            max_temp=m_loop_function(log_H, log_D, m, i);
            log_H(m,i) = max_temp(1,1);
            max_j(m,i) = max_temp(1,2);
        end
      end    
  else
      error('This method has not been implemented or the key arguments are missing.')
  end        
 
 
 if ~exist('max_segs','var')
      max_m=n;
  	  temp_j = max_j(n);
      index_chPTs = [];
      while temp_j > 0
		index_chPTs =[temp_j, index_chPTs];
		max_m = temp_j;
		temp_j=max_j(max_m);
      end
 else
  %Extract Change Points
  [H_max, max_m] = max(log_H(:,n));
  temp_j = max_j(max_m,n);
  index_chPTs = [];
  while temp_j > 0
    index_chPTs = [temp_j, index_chPTs];
    max_m = max_m - 1;
    temp_j = max_j(max_m, temp_j);
  end
 end
  
end


% function use to compute the maximum  
function ans_ch=m_loop_function(A,B,k,l)
   temp.HD = A((k-1), (k-1):(l-1)) + B(k:l);
   [val, idx] = max(temp.HD);
   ans_ch = [val, idx+k-2]; 
end
